
#include "config.h"

#if USE_TINY

#include <avr/io.h>
#include <stdlib.h>

#include "RFM02.h"
#include "TINY.h"

void convert_tiny(uint16_t);

void tiny_read()
{
  asm("nop");

  uint8_t i;
  uint16_t daten = 300;

  ADMUX  = (1<<REFS1) | (1<<MUX3) | (1<<MUX2) | (1<<MUX1) | (1<<MUX0);    // 1,1V Refs, ADC4
  ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);              // ADC ein, Prescale 64 -> 125kHz

  for (i=0; i<3; i++)
    {
      ADCSRA |= (1<<ADSC);                                    //  Start

      while (ADCSRA & (1<<ADSC))                              // warten bis fertig
	      {
		    }

      daten = ADC;                                            // Daten holen 
    } 

  ADCSRA &= ~(1<<ADEN);                                       // ADC aus

  convert_tiny(daten);								                        // umrechnen und in buffer kopieren

}

//-----------------------------------------------------------------------------

void convert_tiny(uint16_t daten)
{
  int16_t temperatur;
  char text[6];                                              // Buffer zur Konvertierung
  uint8_t i = 0, j = 0;

  temperatur = (daten - TINY_OFFSET) * 100; // - TINY_OFFSET

  itoa(abs(temperatur),text,10);

  if (temperatur < 0)
    {
       buffer[SUB_OFFSET_1+j] = '-';
    }
  else
    {
      buffer[SUB_OFFSET_1+j]  = ' ';
    }
  
  j++;
  if (abs(temperatur) < 1000)                                  // nur 1 Stelle vor dem Komma
    {
       buffer[SUB_OFFSET_1+j] = ' ';
    }
  else
    {
      buffer[SUB_OFFSET_1+j]  = text[i];                      // Zehner
      i++;
    }
  j++;
  if (abs(temperatur) < 100)                                   // keine Stelle vor dem Komma
    {
       buffer[SUB_OFFSET_1+j] = '0';
       j++;
    }

   buffer[SUB_OFFSET_1+j]  = text[i];                         // Einer
   i++;
   j++;
   buffer[SUB_OFFSET_1+j] = ',';                              // Komma
   j++;
   buffer[SUB_OFFSET_1+j]  = text[i];                         // Zehntel


}

#endif
